<script lang="ts">
    import { description } from '../common/description'
    import { associations } from '../common/associations'
    import { options } from '../data/options'
    import { toHnetJson } from '../common/hnetFileFormat'
    import format from 'date-fns/format'

    let href: string
    $: href = URL.createObjectURL(new Blob([toHnetJson({
            description: $description,
            options: $options,
            associations: $associations
        })], { type: 'text/json' }))

    let download: string

    $: {
        const filename = $description.filename.replace(/\.[^.]+$/, '')
        const date = new Date($associations.date)
        const timestamp = format(date, 'yyyyMMdd-HHmm')
        download = `${filename}-${timestamp}.hnet`
    }
</script>

<a {href} {download} class="py-2 px-4">
    <slot/>
</a>